;------- TASM ASM mnemonics. -------
; Compile this file using:
; Set TASMOPTS = -b
; tasm -80 ThisCode.tas MyBinary.BIN
;-----------------------------------
; Zx81 Program name: 

#define ORG  .org       ; TASM cross-assembler definitions
#define equ  .equ
#define db  .db
#define dw .word 
;-----------------------------------

#include "ZX81.sym" ; Load the symbol file.

ORG 16514
	LD HL,XBUFFER
	INC HL
	EX DE,HL
	LD HL,XBUFFER
	LD (HL),$00
	LD BC,$300
	LDIR        ; CLEAN DATA BUFFER.
	CALL MAIN
	EX DE,HL
	LD (HL),$40 ; EXIT CODE
	INC HL
	LD (HL),$01
	LD DE,XBUFFER
	SBC HL,DE
	LD B,H    ; ASSIGN DATA LEN
	LD C,L    ; TO BC (USR VALUE)
	RET
MAIN:
	LD DE, XBUFFER    ;BUFFER OFFSET
	LD HL,(RAM_D_FILE);VIDEO RAM OFFSET
	INC HL
	LD B,$18    ; lines counter (24 lines)
Ret1:
	LD A,(HL)
	CP $76
	JR Z,END_TEST
Ret2:
	LD C,$00    ; CHAR COUNTER=0 (<255)

; ARRAY Loop.
; Breaked if the counter if up to 255
; and $76 tag is ignored.
Ret2B:
	INC C     ; CHAR COUNTER
	INC HL    ; VIDEO ADDRESS 

	EX AF,AF' ; AF=COUNTER v

	LD A,(HL) ; TEST AND JUMP 'END OF LINE' TAG
	CP $76
	JR NZ, NXTline ; IF NOT
	DEC B          ;ELSE
	LD A,B         ;UP TO 24 lines?
	RET Z          ;yes
	INC HL         ;no...
NXTline:
	LD A,C
	CP $FF          ; TEST IF COUNTER IS UP TO 255!
	JP Z,End_LoopFF ; RESET COUNTER END WRITE $FF
	EX AF,AF' ; AF=VALUE   ^
	CP (HL)         ; TEST IF THE VALUE IS EQUAL
	JR Z,Ret2B      ; LOOP

End_Loop:
	EX AF,AF' ; AF=COUNTER v
End_LoopFF:
	DEC HL
	OR A
	LD A,C
	SUB $2
	JR NC,ADD_ARRAY ; More than 2 bytes(ARRAY).
	EX AF,AF' ; AF=VALUE ^

ADD_1B:
	LD (DE),A ; WRITE SINGLE CHAR.
	INC DE
Ret3:
	INC HL
	JR Ret1

ADD_ARRAY:        ;WRITE 2BYTES. (CHAR AND BIT6)+(MULTI)
        EX AF,AF' ; AF=VALUE ^
ADD_ARRAYFF:
	OR $40
	LD (DE),A ; CHAR+MULTI-TAG
	INC DE
	LD A,C    ; MULTI
	JR ADD_1B
END_TEST:
	DEC B  ; DEC. LINES
	LD A,B
	RET Z  ; EXIT CALL, IF EQUAL 0
	INC HL ; READ NEXT LINE...
	JR Ret1
XBUFFER:
.end


